<template>
  <div>
    <el-form  size="small" :inline="true"  label-width="110px" style="position: relative;">
      <el-divider content-position="left">阅片规则</el-divider>
      <el-form-item label="是否肿瘤学阅片" style="width: 100%">
        {{ $fd('YesOrNo', IsOncologyReading)}}
      </el-form-item>
      <el-button
        size="mini"
        type="primary"
        style="position: absolute;right: 10px;top: 15px"
        v-if="Object.keys(data).length > 0 && !(data.IsCompleteConfig || data.IsBeUsed)"
        @click="handleAdd(1)"
      >
        配置
      </el-button>
    </el-form>
    <el-form  size="small" :inline="true"  label-width="110px" style="position: relative">
      <el-divider content-position="left">阅片问题</el-divider>
      <el-button
        size="mini"
        type="primary"
        style="position: absolute;right: 10px;top: 15px"
        v-if="Object.keys(data).length > 0 && !(data.IsCompleteConfig || data.IsBeUsed)"
        @click="handleAdd(2)"
      >
        配置
      </el-button>
      <el-form-item label="肿瘤学阅片结果" style="width: 100%">
      </el-form-item>
    </el-form>
    <el-table
      v-loading="loading"
      style="width: 100%"
      :data="list"
      stripe
    >
      <el-table-column
        prop=""
        label="序号"
        width="50"
      >
        <template slot-scope="scope">
          {{scope.$index + 1}}
        </template>
      </el-table-column>
      <el-table-column
        prop="ValueCN"
        label="中文值"
        show-overflow-tooltip
      >
      </el-table-column>
      <el-table-column
        prop="Value"
        label="英文值"
        show-overflow-tooltip
      >
      </el-table-column>
    </el-table>
    <base-model :config="config">
      <template slot="dialog-body">
        <el-form  size="small" :inline="true"  label-width="110px">
          <el-form-item label="是否肿瘤学阅片" v-if="config.configType === 1">
            <el-radio-group v-model="form.IsOncologyReading">
              <el-radio v-for="item of $d.YesOrNo" :key="'form.IsOncologyReading' + item.value" :label="item.value">{{ item.label }}</el-radio>
            </el-radio-group>
          </el-form-item>
          <el-form-item label="肿瘤学阅片结果" style="width: 100%" v-if="config.configType === 2">
          </el-form-item>
          <el-table
            v-if="config.configType === 2"
            v-loading="loading"
            style="width: 100%"
            ref="multipleTable"
            :data="$d.OncologyAssessType"
            stripe
            @selection-change="handleSelectionChange"
          >
            <el-table-column
              type="selection"
              width="55">
            </el-table-column>
            <el-table-column
              prop="raw.ValueCN"
              label="中文值"
              show-overflow-tooltip
            >
            </el-table-column>
            <el-table-column
              prop="raw.Value"
              label="英文值"
              show-overflow-tooltip
            >
            </el-table-column>
          </el-table>
        </el-form>
      </template>
      <template slot="dialog-footer">
        <el-button :disabled="loading" size="small" type="primary" @click="config.visible = false">取消</el-button>
        <el-button size="small" type="primary" :loading="loading" @click="handleSave">保存</el-button>
      </template>
    </base-model>
  </div>
</template>

<script>
import BaseModel from '@/components/BaseModel'
import { getSystemOncologyInfo, setSystemOncologyInfo } from '@/api/dictionary'
export default {
  props: {
    data: {
      type: String,
      default() { return {} }
    },
    criterionId: {
      type: String,
      required: true
    }
  },
  components: { BaseModel },
  data() {
    return {
      form: {
        IsOncologyReading: true
      },
      list: [],
      total: 0,
      loading: false,
      rowData: {},
      activeName: '0',
      addOrEdit: { visible: false, title: '' },
      preview: { visible: false, title: 'eCRF预览' },
      config: { visible: false, title: '肿瘤学阅片结果', appendToBody: true, width: '600px', configType: 0 },
      selectedList: [],
      IsOncologyReading: true
    }
  },
  mounted() {
    this.getList()
  },
  methods: {
    toggleSelection(rows) {
      console.log(this.$refs.multipleTable)
      if (rows) {
        rows.forEach(row => {
          this.$refs.multipleTable.toggleRowSelection(row);
        });
      } else {
        this.$refs.multipleTable.clearSelection();
      }
    },
    handleSelectionChange(val) {
      this.selectedList = val
    },
    getList() {
      this.loading = true
      getSystemOncologyInfo({
        SystemCriterionId: this.criterionId
      }).then(res => {
        this.loading = false
        this.list = res.Result.DictionaryList
        this.IsOncologyReading = res.Result.IsOncologyReading
        this.form.IsOncologyReading = res.Result.IsOncologyReading
        console.log(this.$d.OncologyAssessType)
      })
    },
    handleAdd(n) {
      this.config.configType = n
      if (n === 1) {
        this.config.title = '是否肿瘤学阅片'
        this.config.visible = true
      } else {
        this.config.title = '肿瘤学阅片结果'
        this.config.visible = true
        this.$nextTick(() => {
          var a = this.$d.OncologyAssessType.filter(v => {
            return !!this.list.find(v1 => {
              return v1.DictionaryId === v.id
            })
          })
          this.toggleSelection(a)
        })
      }
    },
    handleSave() {
      this.loading = true
      var a = this.$d.OncologyAssessType.filter(v => {
        return !!this.list.find(v1 => {
          return v1.DictionaryId === v.id
        })
      })
      var params = {
        SystemCriterionId: this.criterionId,
        ParentCode: 'OncologyAssessType',
        DictionaryIds: this.config.configType === 1 ? a.map(v => v.id) : this.selectedList.map(v => v.id),
        IsSystemCriterion: true,
        IsOncologyReading: this.form.IsOncologyReading
      }
      setSystemOncologyInfo(params).then(res => {
        this.loading = false
        this.$message.success(this.$t('common:message:savedSuccessfully'))
        this.config.visible = false
        this.selectedList = []
        this.getList()
      }).catch(() => {
      })
    },
    handleDelete() {

    }
  }
}
</script>

<style scoped>
>>>.el-form-item__content{
  width: calc(100% - 110px);
}
</style>
